#ifndef _TRANSKODE_H_
#define _TRANSKODE_H_

/***************************************************************************
 *   Copyright (C) 2006 by Sergio Pistone                                  *
 *   sergio_pistone@yahoo.com.ar                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
	#include <config.h>
#endif

#include "transkodelistview.h"
#include <transkodelogger.h>
#include <transkodeconfig.h>
#include <transkodedialog.h>
#include <transkodefileworker.h>

#include <kmainwindow.h>
#include <ksystemtray.h>
#include <kaction.h>

class TransKode : public KMainWindow
{
	Q_OBJECT

	public:
		TransKode();
		virtual ~TransKode();

	protected:
		void saveConfig();
		void loadConfig();

		virtual bool queryClose();

		void setupActions();

		typedef enum { idle, transcoding, paused } TState;

	protected slots:

		void slotRoundStarted();
		void slotRoundFinished();

		void slotJobFinished();
		void slotAdded();

		void slotAllCleared();
		void slotFinishedCleared();

		void slotTogglePaused();
		void slotShowPreferences();
		void slotToggleFilterToolBar( bool enabled );
		void slotConfirmQuit();
		void slotUpdateConfig();
		void slotSetActionsState();
		//void setState( TState state );
		void updateState();

	protected:

		TransKodeLogger m_logger;
		TransKodeConfig m_config;
		TransKodeDialog m_configDialog;
		TransKodeFileWorker m_worker;
		TransKodeListView* m_listView;

		KSystemTray* m_systemTray;

		KAction* m_enqueueFilesAction;
		KAction* m_dequeueFilesAction;
		KAction* m_refreshFilesAction;
		KAction* m_selectAllAction;
		KAction* m_invertSelectionAction;
		KAction* m_clearAllAction;
		KAction* m_clearFinishedAction;
		KAction* m_pauseEncodingAction;
		KWidgetAction* m_searchAction;
		KToggleToolBarAction* m_searchManagerAction;

		QString m_lastDir;
};

#endif
