#ifndef _GENERALSETTINGS_UI_H_
#define _GENERALSETTINGS_UI_H_

/***************************************************************************
 *   Copyright (C) 2005 by Sergio Pistone                                  *
 *   sergio_pistone@yahoo.com.ar                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/

#ifdef HAVE_CONFIG_H
	#include <config.h>
#endif

#include <qdir.h>

#include <kfiledialog.h>
#include <kmessagebox.h>

void GeneralSettings::selectLogFile()
{
	QFileInfo fileInfo( logEventsLineEdit->text() );
	QDir startDir( fileInfo.dirPath() );
	if ( !startDir.exists() || startDir.isRelative() )
	{

		startDir.setPath( logEventsLineEdit->text() );
		startDir.convertToAbs();
		if ( !startDir.exists() )
			startDir = QDir::home();
	}

	QString file = KFileDialog::getSaveFileName( startDir.path(), "*.log", this, i18n( "Select log file" ) );
	if ( file != QString::null )
	{
		fileInfo.setFile( file );
		if ( fileInfo.exists() )
			if ( KMessageBox::Yes != KMessageBox::warningYesNo( this,
				i18n( "<qt><b>Choosen file will be truncated</b>.<br/><br/>Use it anyway?</qt>" ),
				"File Exists" ) )
				return;

		logEventsLineEdit->setText( file );
	}
}


void GeneralSettings::selectTempDir()
{
	QFileInfo fileInfo( tempDirLineEdit->text() );
	QDir startDir( fileInfo.dirPath() );
	if ( !startDir.exists() || startDir.isRelative() )
	{

		startDir.setPath( logEventsLineEdit->text() );
		startDir.convertToAbs();
		if ( !startDir.exists() )
			startDir = QDir::home();
	}

	QString dir = KFileDialog::getExistingDirectory( startDir.path(), this, i18n( "Select temporary dir" ) );
	if ( dir != QString::null )
		tempDirLineEdit->setText( dir );
}

#endif
