#ifndef _PROGRAMSETTINGS_H_
#define _PROGRAMSETTINGS_H_

/***************************************************************************
 *   Copyright (C) 2005 by Sergio Pistone                                  *
 *   sergio_pistone@yahoo.com.ar                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
	#include <config.h>
#endif

#include "settingswidget.h"

#include <qgroupbox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qpixmap.h>
#include <qmap.h>

class ProgramSettings : public SettingsWidget
{
	Q_OBJECT

	public:
		ProgramSettings( QWidget* parent = 0, const char* name = 0 );
		virtual ~ProgramSettings();

		virtual bool eventFilter( QObject* watched, QEvent* e );

		QLineEdit* programPathLineEdit( const QString& program );
		QPushButton* guessProgramPathButton( const QString& program );
		QPushButton* selectProgramButton( const QString& program );

	protected:
		virtual void selectProgram( const QString& program );
		virtual void guessProgramPath( const QString& program );

		QMap<QString,QLabel*> m_programLabels;
		QMap<QString,QLineEdit*> m_programPathLineEdits;
		QMap<QString,QPushButton*> m_selectProgramButtons;
		QMap<QString,QPushButton*> m_guessProgramPathButtons;
};

#endif
