#ifndef _TRANSKODEDECODERPLUGIN_H_
#define _TRANSKODEDECODERPLUGIN_H_

/***************************************************************************
 *   Copyright (C) 2005 by Sergio Pistone                                  *
 *   sergio_pistone@yahoo.com.ar                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
	#include <config.h>
#endif

#include "transkodeplugin.h"
#include <qstringlist.h>

class TransKodeDecoderPlugin : public TransKodePlugin
{
	public:
		TransKodeDecoderPlugin( const QString& name=QString::null, const QString& desc=QString::null, const QString& dfltExec=QString::null, QStringList extensions=QStringList() ):
			TransKodePlugin( name, desc, dfltExec, extensions ) {}
		~TransKodeDecoderPlugin() {}

		virtual void setupArgs( QProcessWrapper& proc, const QString& src, const QString& dst ) const = 0;

		bool canDecodeExtension( const QString& extension ) const
		{
			if ( !isLocallySupported() )
				return false;
		
			QString ext = extension.lower();
			for ( QStringList::ConstIterator it = m_extensions.begin(); it != m_extensions.end(); ++it )
				if ( *it == "*" || *it == ext )
					return true;
			return false;
		}
};

#endif
