#ifndef _QDECSPINBOX_H_
#define _QDECSPINBOX_H_

/***************************************************************************
 *   Copyright (C) 2005 by Sergio Pistone                                  *
 *   sergio_pistone@yahoo.com.ar                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
	#include <config.h>
#endif

#include <qspinbox.h>
#include "qdecvalidator.h"

#include <qwidget.h>
#include <qwidgetplugin.h>

class QT_WIDGET_PLUGIN_EXPORT QDecSpinBox : public QSpinBox
{
	Q_OBJECT

	Q_PROPERTY( int decPositions READ decPositions WRITE setDecPositions )
	Q_PROPERTY( double decValue READ decValue WRITE setDecValue )

	public:
		QDecSpinBox( QWidget *parent = 0, const char *name = 0);
		int decPositions() const;
		double decValue() const;

	public slots:
		void setDecPositions( int decimalPos );
		void setDecValue( double v );

	protected:
		virtual QString mapValueToText( int v ); // Redefined
		virtual int mapTextToValue( bool* ok ); // Redefined

	private:
		unsigned decPos;
		unsigned decConst;
		QDecValidator* val;
};

#endif
